﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace daily_planner
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private tasksContext _context;


        public MainWindow()
        {
            InitializeComponent();
            _context = new tasksContext();
            Load();

            DpDeadline.SelectedDate = DateTime.Today;
        }

        // вывод данных
        private void Load()
        {
            tasksGrid.ItemsSource = _context.Tasks.ToList();
        }

        // добавление
        private void Insert_Click(object sender, RoutedEventArgs e)
        {
            InsertTask(TbTask.Text, (DateTime)DpDeadline.SelectedDate);
        }
        public bool InsertTask(string task, DateTime deadline)
        {
            if (string.IsNullOrWhiteSpace(task))
                return false;

            Tasks tsk = new Tasks()
            {
                Task = task,
                Deadline = deadline
            };

            _context.Tasks.Add(tsk);
            _context.SaveChanges();
            Load();

            return true;
        }

        // изменение
        private void Update_Click(object sender, RoutedEventArgs e)
        {
            UpdateTask(TbTask.Text, (DateTime)DpDeadline.SelectedDate);
        }
        public bool UpdateTask(string task, DateTime deadline)
        {
            if (tasksGrid.SelectedItem is Tasks selectedTasks)
            {
                if (string.IsNullOrWhiteSpace(task))
                    return false;

                selectedTasks.Task = task;
                selectedTasks.Deadline = deadline;
                _context.SaveChanges();
                Load();

                return true;
            }

            return false;
        }

        // удаление
        private void Delete_Click(object sender, RoutedEventArgs e)
        {
            DeleteTask();
        }
        public void DeleteTask()
        {
            if (tasksGrid.SelectedItem is Tasks selectedTasks)
            {
                _context.Tasks.Remove(selectedTasks);
                _context.SaveChanges();
                Load();
            }
        }

        // выбор строки
        private void tasksGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (tasksGrid.SelectedItem is Tasks selectedTasks)
            {
                TbTask.Text = selectedTasks.Task;
                DpDeadline.SelectedDate = selectedTasks.Deadline;
            }
        }
    }
}
